#ifndef ERROR_PROPAGATION_GUARD
#define ERROR_PROPAGATION_GUARD 1

/*!
 * @author Cindy Rubio Gonzalez
 */

#include "wali/SemElem.hpp"
#include "wali/WeightFactory.hpp"
#include <string>
#include "fdd.h"
#include <map>
#include "wali/wpds/ewpds/MergeFunction.hpp"
#include "wali/SemElemPair.hpp"
#include <set>



using namespace std;

using wali::SemElem;
using wali::SemElemPair;
using wali::sem_elem_t;
using wali::wpds::ewpds::merge_fn_t;


class ErrorPropagation : public wali::SemElem, public wali::WeightFactory
{
    public:
        ErrorPropagation( bdd b);
        ErrorPropagation( bdd b, set<int> l, string f );
        ErrorPropagation( sem_elem_t s);


        virtual ~ErrorPropagation();

        sem_elem_t one() const;

        sem_elem_t zero() const;

        // zero is the annihilator for extend
        sem_elem_t extend( SemElem* rhs );
        
        // zero is neutral for combine
        sem_elem_t combine( SemElem* rhs );
        
        bool equal( SemElem* rhs ) const;

        std::ostream & print( std::ostream & o ) const;

        // For WeightFactory
        sem_elem_t getWeight( std::string& s );

        // Added by Cindy
        sem_elem_t getWeight( std::string& s1, std::string& s2 );
        sem_elem_t getWeight( std::string& s1, std::string& s2, int line, string f );

        
        bdd BDD;
        set<int> lines;
        string file;
};

#endif	// ERROR_PROPAGATION_GUARD

/*
 * $Log $
 */

/* Yo, Emacs!
;;; Local Variables: ***
;;; tab-width: 4 ***
;;; End: ***
*/

