#include "TransQuery.hpp"
#include "ErrorPropagation.hpp"


extern map<string, int> table;


void TransQuery::operator()( const wali::wfa::Trans * t ) {

  const ErrorPropagation* weight = static_cast<const ErrorPropagation*>( t->weight().get_ptr() );

  int number_of_vars = table.size();
  int index_of_error = table["ERROR"];

  // Constructing the bdd containing all variables mapped to err
  bdd vars_to_error = bddfalse;
  for(int i = 0; i < number_of_vars; i++) {
    if (i != index_of_error) 
      vars_to_error |= (fdd_ithvar(0,i) & (fdd_ithvar(1,index_of_error)));
  }
  
  bdd vars_with_error = weight->BDD & vars_to_error;
  
  if (vars_with_error != bddfalse) {
    o << "Transition:\n";
    o << "===============================\n";
    t->print(o);
    o << "===============================\n";

    o << "Variable(s) containing ERROR: ";

    //Finding variables that could contain error
    int* vars = fdd_scanallvar(vars_with_error);
    while (vars != NULL) {
      o << vars[0] << " ";
      vars_with_error = vars_with_error - (fdd_ithvar(0, vars[0]) & fdd_ithvar(1, vars[1]));
      vars = fdd_scanallvar(vars_with_error);
    }

    o << std::endl << std::endl;
  }
  
}
