#ifndef PROGRAM_POINT_GUARD
#define PROGRAM_POINT_GUARD 1

#include <string>
#include <vector>
#include <map>
#include "ErrorPropagation.hpp"
#include "wali/wfa/WFA.hpp"
#include "wali/wfa/State.hpp"
#include "wali/witness/Witness.hpp"
#include "Variables.hpp"
#include "fdd.h"
#include "FindPathVisitor.hpp"
#include "wali/SemElem.hpp"

using namespace std;

class ProgramPoint {
public:
  ProgramPoint() {}
  ProgramPoint(string f, string func, int l, map<string, string> t, string m, wali::Key fk);

  void calculateWeight(const wali::wfa::WFA& result, const map<wali::Key, wali::wfa::Trans*>& mapTrans);
  void processTargets();

private:
  string file;
  int line;
  string msgcode;
  string function;
  map<string, string> targets;

  wali::Key fromStkKey;

  wali::sem_elem_t weight_for_fromStkKey;
  ErrorPropagation* weight;
  wali::witness::Witness* witness;

  bool interesting(int var, int source, int errorCode);

};

#endif //PROGRAM_POINT_GUARD
