#ifndef VARIABLES_GUARD
#define VARIABLES_GUARD 1

#include <string>
#include <vector>
#include <map>

using namespace std;

class Variables {
public:
  Variables(const string &errorCodes);
  void add(const string &v);
  int getIndex(const string &v);
  string getName(unsigned int i);
  void print(std::ostream& out);
  static int getNumVars();

private:
  static int numVars;
  vector<string> names;
  map<string, int> vars;
};


extern std::auto_ptr<Variables> variables;
extern std::vector<std::string> errorNames;


////////////////////////////////////////////////////////////////////////


inline int Variables::getNumVars()
{
  return numVars;
}


#endif //VARIABLES_GUARD
