from SCons.Builder import Builder
from SCons.Defaults import ObjSourceScan


########################################################################


preprocess_action = [['$CC', '$CPPFLAGS', '$_CPPDEFFLAGS', '$_CPPINCFLAGS', '-E', '-o', '$TARGET', '$SOURCES']]


preprocess_builder = Builder(
    action=preprocess_action,
    suffix='.i',
    src_suffix='.c',
    source_scanner=ObjSourceScan,
    single_source=True
    )


########################################################################


def generate(env):
    env.AppendUnique(BUILDERS={'Preprocess': preprocess_builder})


def exists(env):
    return True
