open Cil

(* components of a set rule *)
type receiver = varinfo
type sender = OK | Code of Error.code | Location of varinfo
type trust = Trusted | Untrusted

(* convert CIL constructs into set rule components, if implemented *)
(* return None if the CIL construct is currently unimplemented *)
val getReceiver : lval -> receiver option
val getSender : exp -> sender option

(* emit a trusted or untrusted set rule from the sender to the receiver *)
val set : out_channel -> receiver -> sender -> trust -> unit

(* emit an unimplemented marker for the given reason *)
val unimplemented : out_channel -> string -> unit
