#ifndef wali_WEIGHT_FACTORY_GUARD
#define wali_WEIGHT_FACTORY_GUARD 1

/*!
 * @author Nick Kidd
 */

#include "wali/Common.hpp"
#include "wali/SemElem.hpp"
#include <string>
#include "wali/wpds/WeightInfo.hpp"
#include <queue>


namespace wali
{
  class WeightFactory
  {
  public:
	WeightFactory();
	
	virtual ~WeightFactory();
	
	virtual wali::sem_elem_t getWeight( std::string& s ) = 0;
	// added by Cindy
	virtual wali::sem_elem_t getWeight( queue<WeightInfo>& weightInfos, int line, string file ) = 0;
	
  }; // class WeightFactory
  
} // namespace wali

#endif  // wali_WEIGHT_FACTORY_GUARD

/* Yo, Emacs!
   ;;; Local Variables: ***
   ;;; tab-width: 4 ***
   ;;; End: ***
*/

